unit MainFrm;

interface

uses
  Windows, Messages, Sysutils, Classes, Graphics, Controls, Forms, Dialogs,
  Comctrls, StdCtrls, extctrls, Menus;

type
  TForm1 = class(TForm)
    CloseButton: TButton;
    PopupMenu1: TPopupMenu;
    Hilfe1: TMenuItem;
    HelpButton: TButton;
    GroupBox1: TGroupBox;
    OffRadioButton: TRadioButton;
    OnRadioButton: TRadioButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    RateTrackBar: TTrackBar;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    ShutDownTimeEdit: TEdit;
    ShutDownTimeUpDown: TUpDown;
    Label9: TLabel;
    ShutDownTimer: TTimer;
    procedure CloseButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RateTrackBarChange(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
    procedure RadioButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
    FFileName: string;
    function GetLoadRate: Integer;
    procedure SetLoadRate(Value: Integer);
    function GetLoadForced: Boolean;
    procedure SetLoadForced(Value: Boolean);
    function GetShutDownTime: Integer;
    procedure SetShutDownTime(Value: Integer);
    procedure SetFileName(Value: string);
    procedure CheckCommandLineParams;
    procedure UpdateCaption;
  public
    { Public-Deklarationen }
    property LoadRate:Integer read GetLoadRate write SetLoadRate;
    property LoadForced: Boolean read GetLoadForced write SetLoadForced;
    property ShutDownTime:Integer read GetShutDownTime write SetShutDownTime;
    property FileName: string read FFileName write SetFileName;
  end;

  Tdings = class(TThread)
     procedure execute; Override;
  public
     maxz : Integer;
  end;

const
  ConstLoadRate = 'Lastfaktor';
  ConstLoadForced = 'Start';
  ConstShutDownTime = 'Ausschaltverzgerung';

var
  Form1: TForm1;
  zahler : longint;
  dings : Tdings;

implementation

uses HelpFrm;

{$R *.DFM}

procedure tdings.execute;
var zahler : longint;
    doof: longint;
begin
  repeat
 {$O-}
  for zahler:= 0 to (maxz*maxz)*5000 do doof:= zahler;
 {$O+}
  sleep(5);
  while suspended do sleep(600);
  until terminated;
end;

{ TForm1 }
function TForm1.GetLoadRate: Integer;
begin
  Result := dings.maxz;
end;

procedure TForm1.SetLoadRate(Value: Integer);
begin
  if Value < RateTrackBar.Min then Value := RateTrackBar.Min;
  if Value > RateTrackBar.Max then Value := RateTrackBar.Max;
  if Value <> LoadRate then dings.maxz := Value;
end;

function TForm1.GetLoadForced: Boolean;
begin
  Result := not dings.Suspended;
end;

procedure TForm1.SetLoadForced(Value: Boolean);
begin
  if Value <> LoadForced then
  begin
    if Value then dings.resume else dings.Suspend;
    if ShutDownTime > 0 then ShutDownTimer.Enabled := LoadForced;
    if FileName <> '' then
    begin
      WinExec(PChar(FileName), SW_SHOW);
      FileName := ''; 
    end;
  end;
end;

function TForm1.GetShutDownTime: Integer;
begin
  Result := ShutDownTimer.Interval div 1000
end;

procedure TForm1.SetShutDownTime(Value: Integer);
begin
  if Value < ShutDownTimeUpDown.Min then Value := ShutDownTimeUpDown.Min;
  if Value > ShutDownTimeUpDown.Max then Value := ShutDownTimeUpDown.Max;
  if Value < 1 then ShutDownTimer.Enabled := False;
  if Value <> ShutDownTime then ShutDownTimer.Interval := Value * 1000;
end;

procedure TForm1.SetFileName(Value: string);
begin
  if not FileExists(Value) then FFileName := ''
  else if not AnsiSameText(FileName, Value) then
    FFileName := Value;
end;

procedure TForm1.CheckCommandLineParams;
var
  CountI: Integer;
  ActParam: string;
  ConstArray: string;
  ParamLoadRate: Integer;
  ParamLoadForced: Boolean;
  ParamShutDownTime: Integer;
  ParamFileName: string;
  DelimPos: Integer;
begin
  ParamLoadRate := LoadRate;
  ParamLoadForced := LoadForced;
  ParamShutDownTime := ShutDownTime;
  ParamFileName :='';
  ConstArray := AnsiUpperCase(';' + ConstLoadRate[1] +
    ';' + ConstLoadForced[1] +
    ';' + ConstShutDownTime[1] + ';');
  for CountI := 1 to ParamCount do
  begin
    ActParam := AnsiUpperCase(ParamStr(CountI));
    if Pos(';' + ActParam[1] + ';', ConstArray) < 1 then
      ActParam := Copy(ActParam, 2, Length(ActParam) - 1);
    if (Pos(ConstLoadRate[1], ActParam) = 1) or
    (Pos(ConstLoadRate, ActParam) = 1) then
    begin
      DelimPos := Pos(':', ActParam);
      if DelimPos > 0 then
      try
         ParamLoadRate := StrToInt(Copy(ActParam, DelimPos + 1, Length(ActParam)));
      except
         ParamLoadRate := LoadRate;
      end;
    end
    else if (Pos(ConstLoadForced[1], ActParam) = 1) or
    (Pos(ConstLoadForced, ActParam) = 1) then
    begin
      ParamLoadForced := True;
      DelimPos := Pos(':', ActParam);
      if DelimPos > 0 then
         ParamFileName := Copy(ActParam, DelimPos + 1, Length(ActParam));
    end
    else if (Pos(ConstShutDownTime[1], ActParam) = 1) or
    (Pos(ConstShutDownTime, ActParam) = 1) then
    begin
      DelimPos := Pos(':', ActParam);
      if DelimPos > 0 then
      try
         ParamShutDownTime := StrToInt(Copy(ActParam, DelimPos + 1, Length(ActParam)));
      except
         ParamShutDownTime := ShutDownTime;
      end;
    end;
  end;
  LoadRate := ParamLoadRate;
  ShutDownTime := ParamShutDownTime;
  FileName := ParamFileName;
  LoadForced := ParamLoadForced;
end;

procedure TForm1.UpdateCaption;
begin
  label1.caption := inttostr(RateTrackBar.position);
  if dings.suspended then
    form1.caption:= 'Bremse AUS'
  else
    form1.caption:= 'Bremse '+ inttostr(RateTrackBar.position)+'%';
end;
procedure TForm1.CloseButtonClick(Sender: TObject);
begin
  dings.Terminate;
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  dings:= tdings.create(true);
  dings.priority:= tpTimeCritical;
  dings.maxz := 0;
end;

procedure TForm1.RateTrackBarChange(Sender: TObject);
begin
  LoadRate := RateTrackBar.Position;
  UpdateCaption;
end;

procedure TForm1.HelpButtonClick(Sender: TObject);
begin
  Form2 := TForm2.Create(Application);
  try
    Form2.ShowModal;
  finally
    Form2.Free;
  end;
end;

procedure TForm1.RadioButtonClick(Sender: TObject);
begin
  LoadForced := OnRadioButton.Checked;
  UpdateCaption;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  GroupBox1.Left := GroupBox1.Top;
  GroupBox2.Left := GroupBox1.Left;
  GroupBox2.Width := GroupBox1.Width;
  CloseButton.Top := GroupBox1.Top + 4;
  CloseButton.Left := (GroupBox1.Left shl 1) + GroupBox1.Width;
  HelpButton.Top := CloseButton.Top + CloseButton.Height + (CloseButton.Top shr 1);
  HelpButton.Left := CloseButton.Left;
  HelpButton.Width := CloseButton.Width;
  ClientHeight := GroupBox2.Top + GroupBox2.Height + GroupBox1.Top;
  ClientWidth := CloseButton.Left + CloseButton.Width + GroupBox1.Left;
  { Parameter auswerten und bernehmen }
  CheckCommandLineParams;
  { Einstellungen anzeigen }
  OnRadioButton.Checked := LoadForced;
  OffRadioButton.Checked := not LoadForced;
  RateTrackBar.Position := LoadRate;
  ShutDownTimeUpDown.Position := ShutDownTime;
end;

end.
